<template>
		<el-form ref="form" :model="model" :rules="rules" @submit.prevent inline
			size="small" 	label-width="150px"
		>
		<el-row class="no-wrap">
			<!-- <el-col> -->
				<el-form-item v-if="search">
					<el-input v-model="model.q" placeholder="Buscar" clearable></el-input>
				</el-form-item>
			<!-- </el-col>
			<el-col> -->
				<slot :fields="model"></slot>
			<!-- </el-col>
			<el-col> -->
				<el-form-item>
					<el-button type="primary" icon="Search" @click="onSubmit"></el-button>
				</el-form-item>
			<!-- </el-col> -->
		</el-row>
		</el-form>
</template>
<script>
export default {
	props:{
		defaults: {
			type: Object,
		},
		search: {
			type: Boolean,
			default: true
		}

	},
	created(){
		if(this.defaults) {
			this.model = this.defaults
			this.$emit('submit', this.model)
		}
	},
	methods: {
		/**
		 * llama al método validate del formulario
		 */
		validate() {
			return this.$refs.form.validate()
		},
		async onSubmit() {
			this.validate().then(()=>{
				this.$emit('submit', this.model)
			}).catch(()=>{
				this.$message({
					type: 'error',
					showClose: true,
					message: 'Por favor, complete los campos requeridos'
				});
			})
		},
	},
	data(){
		return {
			model:{},
			preventEmitInput: true,
		}
	}
}
</script>
<style scoped>
.height-100 {
	height: 100%;
}

.form-main {
	height: calc(100% - 64px);
	padding: 0;
}

</style>

<style lang="css">
.el-form-item__content > div {
	width: 100%;
}

.no-wrap {
	flex-wrap: nowrap !important;
}

</style>
